# std::enable_shared_from_this::enable_shared_from_this

From cppreference.com
< cpp‎ | memory‎ | enable shared from this

constexpr enable_shared_from_this(); | (1) | (since C++11)
enable_shared_from_this( const enable_shared_from_this<T>&obj ); | (2) | (since C++11)

Constructs new `enable_shared_from_this` object. The private std::weak_ptr<T> member is value-initialized.

### Parameters

obj | - | an `enable_shared_from_this` to copy

### Exceptions

`noexcept` specification:
noexcept

### Example

Run this code

    #include <memory>

    struct Foo : public std::enable_shared_from_this<Foo> {
        Foo() {}  // implicitly calls enable_shared_from_this constructor
        std::shared_ptr<Foo> getFoo() { return shared_from_this(); }
    };

    int main() {
        std::shared_ptr<Foo> pf1(new Foo);
        auto pf2 = pf1->getFoo();  // shares ownership of object with pf1
    }

### See also

shared_ptr (C++11) | smart pointer with shared object ownership semantics (class template)

Retrieved from "http://en.cppreference.com/mwiki/index.php?title=cpp/memory/enable_shared_from_this/enable_shared_from_this&oldid=91870"
Category:

- unconditionally noexcept

Hidden categories:

- Pages with unreviewed unconditional noexcept template
- Pages with unreviewed noexcept template